/** @file afh.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef AFH_CMDLINE_H
#define AFH_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef AFH_CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define AFH_CMDLINE_PARSER_PACKAGE "para_afh"
#endif

#ifndef AFH_CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define AFH_CMDLINE_PARSER_PACKAGE_NAME "para_afh"
#endif

#ifndef AFH_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define AFH_CMDLINE_PARSER_VERSION "0.4.2"
#endif

/** @brief Where the command line options are stored */
struct afh_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * loglevel_arg;	/**< @brief set loglevel (default='warning').  */
  char * loglevel_orig;	/**< @brief set loglevel original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel help description.  */
  const char *info_help; /**< @brief select info mode help description.  */
  const char *stream_help; /**< @brief select stream mode help description.  */
  int chunk_table_flag;	/**< @brief print also the chunk table (default=off).  */
  const char *chunk_table_help; /**< @brief print also the chunk table help description.  */
  int human_flag;	/**< @brief use human-readable output format (default=off).  */
  const char *human_help; /**< @brief use human-readable output format help description.  */
  int begin_chunk_arg;	/**< @brief skip a number of chunks (default='0').  */
  char * begin_chunk_orig;	/**< @brief skip a number of chunks original value given at command line.  */
  const char *begin_chunk_help; /**< @brief skip a number of chunks help description.  */
  int end_chunk_arg;	/**< @brief only write up to chunk chunk_num.  */
  char * end_chunk_orig;	/**< @brief only write up to chunk chunk_num original value given at command line.  */
  const char *end_chunk_help; /**< @brief only write up to chunk chunk_num help description.  */
  int just_in_time_flag;	/**< @brief use timed writes (default=off).  */
  const char *just_in_time_help; /**< @brief use timed writes help description.  */
  int no_header_flag;	/**< @brief do not write an audio file header (default=off).  */
  const char *no_header_help; /**< @brief do not write an audio file header help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int info_given ;	/**< @brief Whether info was given.  */
  unsigned int stream_given ;	/**< @brief Whether stream was given.  */
  unsigned int chunk_table_given ;	/**< @brief Whether chunk_table was given.  */
  unsigned int human_given ;	/**< @brief Whether human was given.  */
  unsigned int begin_chunk_given ;	/**< @brief Whether begin_chunk was given.  */
  unsigned int end_chunk_given ;	/**< @brief Whether end_chunk was given.  */
  unsigned int just_in_time_given ;	/**< @brief Whether just_in_time was given.  */
  unsigned int no_header_given ;	/**< @brief Whether no_header was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
  int mode_group_counter; /**< @brief Counter for group mode */
} ;

/** @brief The additional parameters to pass to parser functions */
struct afh_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure afh_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure afh_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *afh_args_info_purpose;
/** @brief the usage string of the program */
extern const char *afh_args_info_usage;
/** @brief all the lines making the help output */
extern const char *afh_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *afh_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int afh_cmdline_parser (int argc, char **argv,
  struct afh_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use afh_cmdline_parser_ext() instead
 */
int afh_cmdline_parser2 (int argc, char **argv,
  struct afh_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int afh_cmdline_parser_ext (int argc, char **argv,
  struct afh_args_info *args_info,
  struct afh_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int afh_cmdline_parser_dump(FILE *outfile,
  struct afh_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int afh_cmdline_parser_file_save(const char *filename,
  struct afh_args_info *args_info);

/**
 * Print the help
 */
void afh_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void afh_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void afh_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a afh_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void afh_cmdline_parser_params_init(struct afh_cmdline_parser_params *params);

/**
 * Allocates dynamically a afh_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized afh_cmdline_parser_params structure
 */
struct afh_cmdline_parser_params *afh_cmdline_parser_params_create(void);

/**
 * Initializes the passed afh_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void afh_cmdline_parser_init (struct afh_args_info *args_info);
/**
 * Deallocates the string fields of the afh_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void afh_cmdline_parser_free (struct afh_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use afh_cmdline_parser_config_file() instead
 */
int afh_cmdline_parser_configfile (const char *filename,
  struct afh_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int afh_cmdline_parser_config_file (const char *filename,
  struct afh_args_info *args_info,
  struct afh_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int afh_cmdline_parser_required (struct afh_args_info *args_info,
  const char *prog_name);

extern const char *afh_cmdline_parser_loglevel_values[];  /**< @brief Possible values for loglevel. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AFH_CMDLINE_H */
